<template>
  <div>
    <!--  Section for viewing questions  -->
    <div id="questions" class="content-container" v-if="allQuestions && !doneWithQuiz">

      <p class="question-number">{{ 'Q:' + currentQuestion }}</p>
      <h3 class="question-text" v-html="allQuestions[currentQuestion-1].question"></h3>

      <QuestionAnswer @answer="registerAnswer" :answer="allQuestions[currentQuestion-1]"></QuestionAnswer>

    </div>
    <!--  Section for viewing results  -->
    <div id="results" class="content-container" v-if="doneWithQuiz">
      <h3 class="question-number">Your score: {{score}} / {{allQuestions.length}}</h3>

      <div v-for="question of allQuestions" v-bind:key="question.question">
      <p class="results" v-html="'Q'+question.qNumber+ ': '+ question.question +'<br> Your answer: '+question.getAnswerSubmit()+'<br> Correct answer: '+question.answers[0]"/>

      </div>
    </div>


  </div>

</template>

<script>

import {fetchQuestions} from "@/api/triviaAPI";
import {makeQuestionList} from "@/components/question";
import QuestionAnswer from "@/components/Question/QuestionAnswers";

export default {
  name: "Question",
  components: {QuestionAnswer},
  created() {
    fetchQuestions().then(allQuestions => {
      console.log(allQuestions.results)
      this.allQuestions = makeQuestionList(allQuestions.results)

    }).catch(error => {
      this.error = error
      console.log(error.message)
    })
  },
  data() {
    return {
      allQuestions: '',
      currentQuestion: 1,
      score: 0,
      error: '',
      doneWithQuiz: false
    }
  },
  methods: {
    nextQuestion: function () {
      this.currentQuestion += 1
    },
    registerAnswer() {
      console.log("SUBMITED " + this.allQuestions[this.currentQuestion-1].getAnswerSubmit())
      const tq = this.allQuestions[this.currentQuestion-1]

      if (tq.getAnswerSubmit() === tq.answers[0]){
        this.score ++
        console.log('CORRECT ANSWER')
      }else{
        console.log('WRONG ANSWER')
      }

      if (this.currentQuestion === this.allQuestions.length){
        console.log('FINISHED WITH THE QUIZ\n ' + this.score + '/' + this.allQuestions.length)
        this.doneWithQuiz = true
      }else{
        this.nextQuestion()
      }
    }
  }
}

</script>

<style>

</style>